<script setup lang="ts">
import { ref } from 'vue'
import { useI18n } from 'vue-i18n'
import { useAppStore } from '../stores/AppStore'

// using
const { t } = useI18n({
    messages: {
        en: {
            locale: "Locale",
            en: "English",
            th: "ไทย",
            theme: "Theme",
            blue: "Blue",
            green: "Green",
            orange: "Orange",
            tone: "Tone",
            default: "Default",
            dark: "Dark",
            lite: "Lite",
        },
        th: {
            locale: "ภาษา",
            en: "English",
            th: "ไทย",
            theme: "ธีมสี",
            blue: "ฟ้า",
            green: "เขียว",
            orange: "ส้ม",
            tone: "โทนสี",
            default: "มาตรฐาน",
            dark: "มืด",
            lite: "สว่าง",
        },
    },
})
const appStore = useAppStore()

// states
const opened = ref(<boolean>false)

// support states
const timer = ref(0)

// ----------------------------------------------------------------------

// exposed API
defineExpose({

    /**
     * Checks if the menu box is opened or not.
     */
    isOpen: function (): boolean {
        return opened.value
    },

    /**
     * Opens menu box.
     * Return true if the menu box is opened successfully.
     * Otherwise, it is false.
     */
    open: function (): boolean {
        return openThis()
    },

    /**
     * Closes the menu box.
     */
    close: function (): void {
        closeThis()
    },

})

// ----------------------------------------------------------------------

function onKeyDownEscape(event: KeyboardEvent) {
    if (event.key === 'Escape') {
        closeThis()
    }
}

function shader(): void {
    if (opened.value) {
        closeThis()
    }
}

function openThis(): boolean {
    // checks if it already opened
    if (opened.value) {
        return false
    }

    opened.value = true
    window.addEventListener('keydown', onKeyDownEscape)

    timer.value = setTimeout(() => {
    }, 0)

    return true
}

function closeThis(): void {
    if (opened.value) {
        clearTimeout(timer.value)
        window.removeEventListener('keydown', onKeyDownEscape)
        opened.value = false
    }
}

function setLocale(locale: string): void {
    appStore.setLocale(locale)
}

function setTheme(theme: string): void {
    appStore.setTheme(theme)
    closeThis()
}

function setTone(tone: string): void {
    appStore.setTone(tone)
    closeThis()
}
</script>


<style scoped>
#container {
    position: fixed;
    width: 100%;
    height: 100%;
    left: 0px;
    top: 0px;
    background: #9999;
}

#platform {
    position: absolute;
    right: 1rem;
    top: 4rem;
}

#menu {
    border-radius: 1rem;
    border: 4px solid #616161;
    box-shadow: 0.25rem 0.25rem #666c;
    padding: 1rem;
    background: #fff;
    color: #000;
}

#menu>section {
    margin: 0 0 1.25rem;
}

#menu>section>h1 {
    border-bottom: 2px solid #9e9e9e;
    font-size: 1.5rem;
    line-height: 2rem;
    margin: 0 0 0.5rem;
}

#menu>section>article {
    display: flex;
    gap: 0.5rem;
    margin: 0 0.5rem;
}

#menu>section>article>button {
    flex: 0 1 auto;
}

#menu ol,
#menu ul {
    list-style: none;
    margin: 0;
    padding: 0;
}

#menu ol>li,
#menu ul>li {
    display: block;
}

#menu ol>li img,
#menu ul>li img {
    vertical-align: middle;
    width: 1rem;
    height: 1rem;
    margin-right: 0.25rem;
}

#menu a {
    color: var(--c-link);
    text-decoration: none;
    cursor: pointer;
}

#menu a:hover,
#menu a:active {
    text-decoration: underline;
}

#menu button {
    display: inline-flex;
    align-items: center;
    padding: 0.25rem 0.5rem;
    margin: 0 0.25rem 0 0;
    cursor: pointer;
}

#menu button>i {
    width: 1.5rem;
    height: 1.5rem;
    margin-right: 0.25rem;
}

.animate {
    animation-duration: .5s;
    animation-name: in;
}

@keyframes in {
    from {
        opacity: 0;
    }

    to {
        opacity: 1;
    }
}
</style>


<template>
    <!-- background -->
    <div v-if="opened" id="container" @click.prevent.stop="shader">
        <!-- menu hover platform -->
        <div id="platform" @click.prevent.stop="">
            <!-- menu -->
            <div id="menu" class="animate">
                <section>
                    <h1>{{ t('locale') }}</h1>
                    <article>
                        <ul>
                            <li>
                                <RouterLink class="a" to="#" @click.prevent="setLocale('en')">
                                    <img src="../assets/images/locale-en.svg" :alt="t('en')" />
                                    <span>{{ t('en') }}</span>
                                </RouterLink>
                            </li>
                            <li>
                                <RouterLink class="a" to="#" @click.prevent="setLocale('th')">
                                    <img src="../assets/images/locale-th.svg" :alt="t('th')" />
                                    <span>{{ t('th') }}</span>
                                </RouterLink>
                            </li>
                        </ul>
                    </article>
                </section>

                <section>
                    <h1>{{ t('theme') }}</h1>
                    <article>
                        <button @click.prevent="setTheme('blue')">
                            <i class="material-symbols-rounded" style="color: #369">favorite</i>
                            <span>{{ t('blue') }}</span>
                        </button>
                        <button @click.prevent="setTheme('green')">
                            <i class="material-symbols-rounded" style="color: #396">favorite</i>
                            <span>{{ t('green') }}</span>
                        </button>
                        <button @click.prevent="setTheme('orange')">
                            <i class="material-symbols-rounded" style="color: #f63">favorite</i>
                            <span>{{ t('orange') }}</span>
                        </button>
                    </article>
                </section>

                <section>
                    <h1>{{ t('tone') }}</h1>
                    <article>
                        <button @click.prevent="setTone('default')">
                            <i class="material-symbols-outlined" style="color: #999">favorite</i>
                            <span>{{ t('default') }}</span>
                        </button>
                        <button @click.prevent="setTone('dark')">
                            <i class="material-symbols-rounded" style="color: #000">favorite</i>
                            <span>{{ t('dark') }}</span>
                        </button>
                        <button @click.prevent="setTone('lite')">
                            <i class="material-symbols-rounded" style="color: #fff">favorite</i>
                            <span>{{ t('lite') }}</span>
                        </button>
                    </article>
                </section>
            </div>
        </div>
    </div>
</template>
